var WIDGET_VERSION="v1.0";
var g_arySportXml=null;
var g_aryTextResults=null;
var g_aryDividers=null;

loadText();
showLoading(true);
loadSports();
loadResultsData();

function loadText() {
	textSport.data="Currently displaying: " + preferences.prefSportName.value;
	if((parseInt(preferences.prefSportID.value)==7)&&(preferences.prefIgnorePlaceMarkets.value==1))
		textSport.data+=" [HIDING PLACE MARKETS]";
}

function loadSports() {
	var url=new URL();
	url.setRequestHeader("User-Agent", "Konfabulator results widget (" + WIDGET_VERSION + ")");
	url.location=preferences.prefBaseURL.value + "Navigation.aspx?m=xml";
	url.fetchAsync(asyncLoadSportsHandler);
}

function asyncLoadSportsHandler(url) {
	g_arySportXml=loadElements(url.responseData, "Sport", -1, false);
	winMain.contextMenuItems=getSportMenuItems();
	delete url;
}

function getSportMenuItems() {
	var items=new Array();
	if(g_arySportXml!=null) {
		if(g_arySportXml.length>0) {
			for(var i=0; i<g_arySportXml.length; i++) {
				var sName=getElement("Name", g_arySportXml[i]);
				var mi=new MenuItem();
				mi.title=sName;
				mi.onSelect="setSport('" + sName + "', '" + getElement("SportID", g_arySportXml[i]) + "', '" + getElement("CountryID", g_arySportXml[i]) + "');";
				items.push(mi);
			}
		}
		else {
			var mi=new MenuItem();
			mi.title="No sports found";
			mi.onSelect="void(0);";
			items.push(mi);
		}
	}
	return(items);
}

function setSport(sName, sSportID, sCountryID) {
	showLoading(true);
	preferences.prefSportName.value=sName;
	preferences.prefSportID.value=sSportID;
	preferences.prefCountryID.value=(sCountryID==""?-1:sCountryID);
	loadText();
	loadResultsData();
}

function loadResultsData() {
	var url=new URL();
	url.setRequestHeader("User-Agent", "Konfabulator results widget (" + WIDGET_VERSION + ")");
	url.location=preferences.prefBaseURL.value + "RSS.aspx?format=rss&sportID=" + preferences.prefSportID.value + (((preferences.prefCountryID.value.length>0)&&(preferences.prefCountryID.value!=-1))?"&countryID=" + preferences.prefCountryID.value:"");
	url.fetchAsync(asyncLoadResultsData);
}

function asyncLoadResultsData(url) {
	var aryMarkets=loadElements(url.responseData, "item", 7, (parseInt(preferences.prefSportID.value)==7));
	delete url;
	if(aryMarkets.length>0) {
		showMessage("", false);
		if(g_aryTextResults==null)
			initObjects();
		else {
			for(var i=0; i<g_aryTextResults.length; i++) {
				g_aryTextResults[i].data="";
				g_aryTextResults[i].onMouseUp="";
			}
		}
		var iIndex=0;
		for(var i=0; i<aryMarkets.length; i++) {
			g_aryTextResults[iIndex].data=getElement("title", aryMarkets[i]);
			g_aryTextResults[iIndex].onMouseUp="openURL(getLinkToSport());";
			g_aryTextResults[iIndex+1].data=getElement("description", aryMarkets[i]);
			g_aryTextResults[iIndex+1].onMouseUp="openURL(getLinkToSport());";
			iIndex+=2;
		}
	}
	else {
		showMessage("No markets have been settled within the last 24 hours for this sport", true);
	}
	showLoading(false);
}

function initObjects() {
	g_aryTextResults=new Array();
	g_aryDividers=new Array();
	for(var i=0; i<=7; i++) {
		var txtMarket=new Text();
		txtMarket.hOffset=20;
		txtMarket.vOffset=29*(i+1)+50;
		txtMarket.size=11;
		txtMarket.style="bold";					
		txtMarket.width=450;
		txtMarket.truncation="end";
		g_aryTextResults.push(txtMarket);
		var txtWinners=new Text();
		txtWinners.hOffset=30;
		txtWinners.vOffset=txtMarket.vOffset+12;
		txtWinners.size=11;		
		txtWinners.width=450;
		txtWinners.truncation="end";					
		g_aryTextResults.push(txtWinners);
		if(i<6) {
			var imageDivider=new Image();
			imageDivider.src="Resources\\images\\divider.png";
			imageDivider.hOffset=14;
			imageDivider.vOffset=txtWinners.vOffset+4;
			imageDivider.zOrder=10;
			g_aryDividers.push(imageDivider);
		}
	}
}

function showLoading(bShow) {
	if(bShow)
		showMessage("", false)
	textLoading.zOrder=(bShow?2:0);
	updateNow();
}

function showMessage(sMsg, bShow) {
	if(bShow)
		showLoading(false);
	textMessage.data=sMsg;
	textMessage.zOrder=(bShow?2:0);
}

function getLinkToSport() {
	return(preferences.prefBaseURL.value + "Index.aspx?format=html&sportID=" + preferences.prefSportID.value + (((preferences.prefCountryID.value.length>0)&&(preferences.prefCountryID.value!=-1))?"&countryID=" + preferences.prefCountryID.value:""));
}

function loadElements(sXml, sElementName, iTopCount, bHorseRacing) {
	var sUnprocessed=sXml;
	var iNode=0;
	var ary = new Array();
	while((sUnprocessed.indexOf("<" + sElementName + ">")>-1)&&(sUnprocessed.indexOf("</" + sElementName + ">")>-1)&&((iNode<iTopCount)||(iTopCount==-1))) {
		var bIgnore=false;
		var iS=sUnprocessed.indexOf("<" + sElementName + ">");
		var iE=sUnprocessed.indexOf("</" + sElementName + ">");
		var sData=sUnprocessed.substring(iS+2+sElementName.length, iE);
		if((bHorseRacing)&&(preferences.prefIgnorePlaceMarkets.value==1))
			bIgnore=(sData.indexOf("TO BE PLACED")>-1);
		if(!bIgnore) {
			ary.push(sData);
			iNode++;
		}
		sUnprocessed=sUnprocessed.substr(iE+3+sElementName.length);
	}
	return(ary);
}

function getElement(sElementName, sXml) {
	var sData="";
	try {
		if(sXml.indexOf("<" + sElementName + ">")>-1) {
			sData=sXml.substring(sXml.indexOf("<" + sElementName + ">")+sElementName.length+2, sXml.indexOf("</" + sElementName + ">"));
		}
	}
	catch(e) {
		print("Error: " + e);
	}
	return(sData);
}